Index: /trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj	(revision 1585)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj	(revision 1586)
@@ -113,4 +113,10 @@
     <Compile Include="MaxAggregator.cs" />
     <Compile Include="MinAggregator.cs" />
+    <Compile Include="Options\Options.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Options\Options.Designer.cs">
+      <DependentUpon>Options.cs</DependentUpon>
+    </Compile>
     <Compile Include="Options\OptionsDialog.cs">
       <SubType>Form</SubType>
@@ -174,4 +180,7 @@
       <DependentUpon>LineChart.cs</DependentUpon>
       <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Options\Options.resx">
+      <DependentUpon>Options.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Options\OptionsDialog.resx">
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs	(revision 1586)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs	(revision 1586)
@@ -0,0 +1,396 @@
+﻿namespace HeuristicLab.Visualization.Options {
+  partial class Options {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.Optionstabs = new System.Windows.Forms.TabControl();
+      this.tabPage1 = new System.Windows.Forms.TabPage();
+      this.OptionsDialogSelectColorBtn = new System.Windows.Forms.Button();
+      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
+      this.label2 = new System.Windows.Forms.Label();
+      this.LinestyleCB = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.LineSelectCB = new System.Windows.Forms.ComboBox();
+      this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.MarkercheckBox = new System.Windows.Forms.CheckBox();
+      this.label4 = new System.Windows.Forms.Label();
+      this.LineThicknessCB = new System.Windows.Forms.ComboBox();
+      this.label3 = new System.Windows.Forms.Label();
+      this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.btnChangeLegendFont = new System.Windows.Forms.Button();
+      this.legendposition = new System.Windows.Forms.Label();
+      this.cbLegendPosition = new System.Windows.Forms.ComboBox();
+      this.tpTitle = new System.Windows.Forms.TabPage();
+      this.btnChangeTitleFont = new System.Windows.Forms.Button();
+      this.tpXAxis = new System.Windows.Forms.TabPage();
+      this.btnChangeXAxisFont = new System.Windows.Forms.Button();
+      this.tpYAxes = new System.Windows.Forms.TabPage();
+      this.gbxYAxisClipChangeable = new System.Windows.Forms.GroupBox();
+      this.flpYAxisClipChangeable = new System.Windows.Forms.FlowLayoutPanel();
+      this.gbxShowYAxis = new System.Windows.Forms.GroupBox();
+      this.flpShowYAxis = new System.Windows.Forms.FlowLayoutPanel();
+      this.fdFont = new System.Windows.Forms.FontDialog();
+      this.Optionstabs.SuspendLayout();
+      this.tabPage1.SuspendLayout();
+      this.groupBox1.SuspendLayout();
+      this.tabPage2.SuspendLayout();
+      this.tpTitle.SuspendLayout();
+      this.tpXAxis.SuspendLayout();
+      this.tpYAxes.SuspendLayout();
+      this.gbxYAxisClipChangeable.SuspendLayout();
+      this.gbxShowYAxis.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // Optionstabs
+      // 
+      this.Optionstabs.Controls.Add(this.tabPage1);
+      this.Optionstabs.Controls.Add(this.tabPage2);
+      this.Optionstabs.Controls.Add(this.tpTitle);
+      this.Optionstabs.Controls.Add(this.tpXAxis);
+      this.Optionstabs.Controls.Add(this.tpYAxes);
+      this.Optionstabs.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.Optionstabs.Location = new System.Drawing.Point(0, 0);
+      this.Optionstabs.Name = "Optionstabs";
+      this.Optionstabs.SelectedIndex = 0;
+      this.Optionstabs.Size = new System.Drawing.Size(298, 232);
+      this.Optionstabs.TabIndex = 1;
+      // 
+      // tabPage1
+      // 
+      this.tabPage1.Controls.Add(this.OptionsDialogSelectColorBtn);
+      this.tabPage1.Controls.Add(this.ColorPreviewTB);
+      this.tabPage1.Controls.Add(this.label2);
+      this.tabPage1.Controls.Add(this.LinestyleCB);
+      this.tabPage1.Controls.Add(this.label1);
+      this.tabPage1.Controls.Add(this.LineSelectCB);
+      this.tabPage1.Controls.Add(this.groupBox1);
+      this.tabPage1.Location = new System.Drawing.Point(4, 22);
+      this.tabPage1.Name = "tabPage1";
+      this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage1.Size = new System.Drawing.Size(290, 206);
+      this.tabPage1.TabIndex = 0;
+      this.tabPage1.Text = "Linestyle";
+      this.tabPage1.UseVisualStyleBackColor = true;
+      // 
+      // OptionsDialogSelectColorBtn
+      // 
+      this.OptionsDialogSelectColorBtn.Location = new System.Drawing.Point(217, 126);
+      this.OptionsDialogSelectColorBtn.Name = "OptionsDialogSelectColorBtn";
+      this.OptionsDialogSelectColorBtn.Size = new System.Drawing.Size(50, 23);
+      this.OptionsDialogSelectColorBtn.TabIndex = 7;
+      this.OptionsDialogSelectColorBtn.Text = "Select";
+      this.OptionsDialogSelectColorBtn.UseVisualStyleBackColor = true;
+      this.OptionsDialogSelectColorBtn.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
+      // 
+      // ColorPreviewTB
+      // 
+      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
+      this.ColorPreviewTB.Name = "ColorPreviewTB";
+      this.ColorPreviewTB.ReadOnly = true;
+      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
+      this.ColorPreviewTB.TabIndex = 6;
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(36, 80);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(30, 13);
+      this.label2.TabIndex = 3;
+      this.label2.Text = "Style";
+      // 
+      // LinestyleCB
+      // 
+      this.LinestyleCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LinestyleCB.FormattingEnabled = true;
+      this.LinestyleCB.Location = new System.Drawing.Point(146, 73);
+      this.LinestyleCB.Name = "LinestyleCB";
+      this.LinestyleCB.Size = new System.Drawing.Size(121, 21);
+      this.LinestyleCB.TabIndex = 2;
+      this.LinestyleCB.SelectedIndexChanged += new System.EventHandler(this.LinestyleCB_SelectedIndexChanged);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(7, 37);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(72, 13);
+      this.label1.TabIndex = 1;
+      this.label1.Text = "Selected Line";
+      // 
+      // LineSelectCB
+      // 
+      this.LineSelectCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LineSelectCB.FormattingEnabled = true;
+      this.LineSelectCB.Location = new System.Drawing.Point(146, 30);
+      this.LineSelectCB.Name = "LineSelectCB";
+      this.LineSelectCB.Size = new System.Drawing.Size(121, 21);
+      this.LineSelectCB.TabIndex = 0;
+      this.LineSelectCB.SelectedIndexChanged += new System.EventHandler(this.LineSelectCB_SelectedIndexChanged);
+      // 
+      // groupBox1
+      // 
+      this.groupBox1.Controls.Add(this.MarkercheckBox);
+      this.groupBox1.Controls.Add(this.label4);
+      this.groupBox1.Controls.Add(this.LineThicknessCB);
+      this.groupBox1.Controls.Add(this.label3);
+      this.groupBox1.Location = new System.Drawing.Point(4, 54);
+      this.groupBox1.Name = "groupBox1";
+      this.groupBox1.Size = new System.Drawing.Size(274, 129);
+      this.groupBox1.TabIndex = 9;
+      this.groupBox1.TabStop = false;
+      this.groupBox1.Text = "Details";
+      // 
+      // MarkercheckBox
+      // 
+      this.MarkercheckBox.AutoSize = true;
+      this.MarkercheckBox.Location = new System.Drawing.Point(142, 106);
+      this.MarkercheckBox.Name = "MarkercheckBox";
+      this.MarkercheckBox.Size = new System.Drawing.Size(59, 17);
+      this.MarkercheckBox.TabIndex = 9;
+      this.MarkercheckBox.Text = "Marker";
+      this.MarkercheckBox.UseVisualStyleBackColor = true;
+      this.MarkercheckBox.CheckedChanged += new System.EventHandler(this.MarkercheckBox_CheckedChanged);
+      // 
+      // label4
+      // 
+      this.label4.AutoSize = true;
+      this.label4.Location = new System.Drawing.Point(33, 77);
+      this.label4.Name = "label4";
+      this.label4.Size = new System.Drawing.Size(31, 13);
+      this.label4.TabIndex = 8;
+      this.label4.Text = "Color";
+      // 
+      // LineThicknessCB
+      // 
+      this.LineThicknessCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LineThicknessCB.FormattingEnabled = true;
+      this.LineThicknessCB.Location = new System.Drawing.Point(142, 46);
+      this.LineThicknessCB.Name = "LineThicknessCB";
+      this.LineThicknessCB.Size = new System.Drawing.Size(121, 21);
+      this.LineThicknessCB.TabIndex = 4;
+      this.LineThicknessCB.SelectedIndexChanged += new System.EventHandler(this.LineThicknessCB_SelectedIndexChanged);
+      // 
+      // label3
+      // 
+      this.label3.AutoSize = true;
+      this.label3.Location = new System.Drawing.Point(32, 52);
+      this.label3.Name = "label3";
+      this.label3.Size = new System.Drawing.Size(56, 13);
+      this.label3.TabIndex = 5;
+      this.label3.Text = "Thickness";
+      // 
+      // tabPage2
+      // 
+      this.tabPage2.Controls.Add(this.btnChangeLegendFont);
+      this.tabPage2.Controls.Add(this.legendposition);
+      this.tabPage2.Controls.Add(this.cbLegendPosition);
+      this.tabPage2.Location = new System.Drawing.Point(4, 22);
+      this.tabPage2.Name = "tabPage2";
+      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage2.Size = new System.Drawing.Size(290, 206);
+      this.tabPage2.TabIndex = 1;
+      this.tabPage2.Text = "Legend";
+      this.tabPage2.UseVisualStyleBackColor = true;
+      // 
+      // btnChangeLegendFont
+      // 
+      this.btnChangeLegendFont.Location = new System.Drawing.Point(3, 6);
+      this.btnChangeLegendFont.Name = "btnChangeLegendFont";
+      this.btnChangeLegendFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeLegendFont.TabIndex = 2;
+      this.btnChangeLegendFont.Text = "Change Font";
+      this.btnChangeLegendFont.UseVisualStyleBackColor = true;
+      this.btnChangeLegendFont.Click += new System.EventHandler(this.btnChangeLegendFont_Click);
+      // 
+      // legendposition
+      // 
+      this.legendposition.AutoSize = true;
+      this.legendposition.Location = new System.Drawing.Point(8, 38);
+      this.legendposition.Name = "legendposition";
+      this.legendposition.Size = new System.Drawing.Size(82, 13);
+      this.legendposition.TabIndex = 1;
+      this.legendposition.Text = "Legendposition:";
+      // 
+      // cbLegendPosition
+      // 
+      this.cbLegendPosition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.cbLegendPosition.FormattingEnabled = true;
+      this.cbLegendPosition.Location = new System.Drawing.Point(96, 35);
+      this.cbLegendPosition.Name = "cbLegendPosition";
+      this.cbLegendPosition.Size = new System.Drawing.Size(121, 21);
+      this.cbLegendPosition.TabIndex = 0;
+      this.cbLegendPosition.SelectedIndexChanged += new System.EventHandler(this.cbLegendPosition_SelectedIndexChanged);
+      // 
+      // tpTitle
+      // 
+      this.tpTitle.Controls.Add(this.btnChangeTitleFont);
+      this.tpTitle.Location = new System.Drawing.Point(4, 22);
+      this.tpTitle.Name = "tpTitle";
+      this.tpTitle.Size = new System.Drawing.Size(290, 206);
+      this.tpTitle.TabIndex = 2;
+      this.tpTitle.Text = "Title";
+      this.tpTitle.UseVisualStyleBackColor = true;
+      // 
+      // btnChangeTitleFont
+      // 
+      this.btnChangeTitleFont.Location = new System.Drawing.Point(3, 3);
+      this.btnChangeTitleFont.Name = "btnChangeTitleFont";
+      this.btnChangeTitleFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeTitleFont.TabIndex = 1;
+      this.btnChangeTitleFont.Text = "Change Font";
+      this.btnChangeTitleFont.UseVisualStyleBackColor = true;
+      this.btnChangeTitleFont.Click += new System.EventHandler(this.btnChangeTitleFont_Click);
+      // 
+      // tpXAxis
+      // 
+      this.tpXAxis.Controls.Add(this.btnChangeXAxisFont);
+      this.tpXAxis.Location = new System.Drawing.Point(4, 22);
+      this.tpXAxis.Name = "tpXAxis";
+      this.tpXAxis.Size = new System.Drawing.Size(290, 206);
+      this.tpXAxis.TabIndex = 3;
+      this.tpXAxis.Text = "X-Axis";
+      this.tpXAxis.UseVisualStyleBackColor = true;
+      // 
+      // btnChangeXAxisFont
+      // 
+      this.btnChangeXAxisFont.Location = new System.Drawing.Point(3, 3);
+      this.btnChangeXAxisFont.Name = "btnChangeXAxisFont";
+      this.btnChangeXAxisFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeXAxisFont.TabIndex = 2;
+      this.btnChangeXAxisFont.Text = "Change Font";
+      this.btnChangeXAxisFont.UseVisualStyleBackColor = true;
+      this.btnChangeXAxisFont.Click += new System.EventHandler(this.btnChangeXAxisFont_Click);
+      // 
+      // tpYAxes
+      // 
+      this.tpYAxes.Controls.Add(this.gbxYAxisClipChangeable);
+      this.tpYAxes.Controls.Add(this.gbxShowYAxis);
+      this.tpYAxes.Location = new System.Drawing.Point(4, 22);
+      this.tpYAxes.Name = "tpYAxes";
+      this.tpYAxes.Padding = new System.Windows.Forms.Padding(3);
+      this.tpYAxes.Size = new System.Drawing.Size(290, 206);
+      this.tpYAxes.TabIndex = 4;
+      this.tpYAxes.Text = "Y-Axes";
+      this.tpYAxes.UseVisualStyleBackColor = true;
+      // 
+      // gbxYAxisClipChangeable
+      // 
+      this.gbxYAxisClipChangeable.AutoSize = true;
+      this.gbxYAxisClipChangeable.Controls.Add(this.flpYAxisClipChangeable);
+      this.gbxYAxisClipChangeable.Location = new System.Drawing.Point(0, 82);
+      this.gbxYAxisClipChangeable.Name = "gbxYAxisClipChangeable";
+      this.gbxYAxisClipChangeable.Size = new System.Drawing.Size(281, 76);
+      this.gbxYAxisClipChangeable.TabIndex = 1;
+      this.gbxYAxisClipChangeable.TabStop = false;
+      this.gbxYAxisClipChangeable.Text = "Y-Axis-Clip changeable";
+      // 
+      // flpYAxisClipChangeable
+      // 
+      this.flpYAxisClipChangeable.AutoSize = true;
+      this.flpYAxisClipChangeable.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.flpYAxisClipChangeable.FlowDirection = System.Windows.Forms.FlowDirection.TopDown;
+      this.flpYAxisClipChangeable.Location = new System.Drawing.Point(3, 16);
+      this.flpYAxisClipChangeable.Name = "flpYAxisClipChangeable";
+      this.flpYAxisClipChangeable.Size = new System.Drawing.Size(275, 57);
+      this.flpYAxisClipChangeable.TabIndex = 0;
+      // 
+      // gbxShowYAxis
+      // 
+      this.gbxShowYAxis.AutoSize = true;
+      this.gbxShowYAxis.Controls.Add(this.flpShowYAxis);
+      this.gbxShowYAxis.Location = new System.Drawing.Point(0, 0);
+      this.gbxShowYAxis.Name = "gbxShowYAxis";
+      this.gbxShowYAxis.Size = new System.Drawing.Size(281, 76);
+      this.gbxShowYAxis.TabIndex = 0;
+      this.gbxShowYAxis.TabStop = false;
+      this.gbxShowYAxis.Text = "Show Y-Axis";
+      // 
+      // flpShowYAxis
+      // 
+      this.flpShowYAxis.AutoSize = true;
+      this.flpShowYAxis.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.flpShowYAxis.FlowDirection = System.Windows.Forms.FlowDirection.TopDown;
+      this.flpShowYAxis.Location = new System.Drawing.Point(3, 16);
+      this.flpShowYAxis.Name = "flpShowYAxis";
+      this.flpShowYAxis.Size = new System.Drawing.Size(275, 57);
+      this.flpShowYAxis.TabIndex = 0;
+      // 
+      // Options
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.Optionstabs);
+      this.Name = "Options";
+      this.Size = new System.Drawing.Size(298, 232);
+      this.Load += new System.EventHandler(this.Options_Load);
+      this.Optionstabs.ResumeLayout(false);
+      this.tabPage1.ResumeLayout(false);
+      this.tabPage1.PerformLayout();
+      this.groupBox1.ResumeLayout(false);
+      this.groupBox1.PerformLayout();
+      this.tabPage2.ResumeLayout(false);
+      this.tabPage2.PerformLayout();
+      this.tpTitle.ResumeLayout(false);
+      this.tpXAxis.ResumeLayout(false);
+      this.tpYAxes.ResumeLayout(false);
+      this.tpYAxes.PerformLayout();
+      this.gbxYAxisClipChangeable.ResumeLayout(false);
+      this.gbxYAxisClipChangeable.PerformLayout();
+      this.gbxShowYAxis.ResumeLayout(false);
+      this.gbxShowYAxis.PerformLayout();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TabControl Optionstabs;
+    private System.Windows.Forms.TabPage tabPage1;
+    private System.Windows.Forms.Button OptionsDialogSelectColorBtn;
+    private System.Windows.Forms.TextBox ColorPreviewTB;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.ComboBox LinestyleCB;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.ComboBox LineSelectCB;
+    private System.Windows.Forms.GroupBox groupBox1;
+    private System.Windows.Forms.CheckBox MarkercheckBox;
+    private System.Windows.Forms.Label label4;
+    private System.Windows.Forms.ComboBox LineThicknessCB;
+    private System.Windows.Forms.Label label3;
+    private System.Windows.Forms.TabPage tabPage2;
+    private System.Windows.Forms.Button btnChangeLegendFont;
+    private System.Windows.Forms.Label legendposition;
+    private System.Windows.Forms.ComboBox cbLegendPosition;
+    private System.Windows.Forms.TabPage tpTitle;
+    private System.Windows.Forms.Button btnChangeTitleFont;
+    private System.Windows.Forms.TabPage tpXAxis;
+    private System.Windows.Forms.Button btnChangeXAxisFont;
+    private System.Windows.Forms.TabPage tpYAxes;
+    private System.Windows.Forms.GroupBox gbxYAxisClipChangeable;
+    private System.Windows.Forms.FlowLayoutPanel flpYAxisClipChangeable;
+    private System.Windows.Forms.GroupBox gbxShowYAxis;
+    private System.Windows.Forms.FlowLayoutPanel flpShowYAxis;
+    private System.Windows.Forms.FontDialog fdFont;
+  }
+}
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1586)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1586)
@@ -0,0 +1,234 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Windows.Forms;
+using HeuristicLab.Visualization.Legend;
+
+namespace HeuristicLab.Visualization.Options {
+  public partial class Options : UserControl {
+    private IChartDataRowsModel model;
+    private ViewSettings viewSettings;
+    private ViewSettings oldViewSettings;
+    private LineParams[] oldLineParams;
+    private Dictionary<CheckBox, bool> ShowYAxisBoxes;
+    private Dictionary<CheckBox, bool> yAxisClipChangeableBoxes;
+
+    internal class LineParams {
+      private string Label { get; set; }
+      private Color Color { get; set; }
+      private bool ShowMarkers { get; set; }
+      private int Thickness { get; set; }
+      private DrawingStyle Style { get; set; }
+      private readonly IDataRow row;
+
+      public LineParams(IDataRow row) {
+        Label = row.Label;
+        Color = row.Color;
+        Thickness = row.Thickness;
+        Style = row.Style;
+        this.row = row;
+        this.ShowMarkers = row.ShowMarkers;
+      }
+
+      public void applySettings() {
+        row.Label = Label;
+        row.Color = Color;
+        row.Thickness = Thickness;
+        row.Style = Style;
+        row.ShowMarkers = this.ShowMarkers;
+      }
+    }
+
+    public Options() {
+      InitializeComponent();
+
+      cbLegendPosition.Items.Add(LegendPosition.Top);
+      cbLegendPosition.Items.Add(LegendPosition.Bottom);
+      cbLegendPosition.Items.Add(LegendPosition.Left);
+      cbLegendPosition.Items.Add(LegendPosition.Right);
+
+      Model = new ChartDataRowsModel();
+    }
+
+    public IChartDataRowsModel Model {
+      get { return model; }
+      set {
+        model = value;
+        viewSettings = model.ViewSettings;
+        oldViewSettings = new ViewSettings(model.ViewSettings);
+        cbLegendPosition.SelectedItem = viewSettings.LegendPosition;
+      }
+    }
+
+    public void ResetSettings() {
+      foreach (var param in oldLineParams) {
+        param.applySettings();
+      }
+
+      foreach (var box in ShowYAxisBoxes) {
+        box.Key.Checked = box.Value;
+      }
+
+      foreach (KeyValuePair<CheckBox, bool> box in yAxisClipChangeableBoxes) {
+        box.Key.Checked = box.Value;
+      }
+
+      viewSettings.LegendColor = oldViewSettings.LegendColor;
+      viewSettings.LegendPosition = oldViewSettings.LegendPosition;
+      viewSettings.LegendFont = oldViewSettings.LegendFont;
+      viewSettings.TitleColor = oldViewSettings.TitleColor;
+      viewSettings.TitleFont = oldViewSettings.TitleFont;
+      viewSettings.XAxisColor = oldViewSettings.LegendColor;
+      viewSettings.XAxisFont = oldViewSettings.XAxisFont;
+      viewSettings.UpdateView();
+      cbLegendPosition.SelectedItem = viewSettings.LegendPosition;
+      this.LineSelectCB_SelectedIndexChanged(this, null);
+    }
+
+    private void OptionsDialogSelectColorBtn_Click(object sender, EventArgs e) {
+      ColorDialog dlg = new ColorDialog();
+      dlg.ShowDialog();
+      ColorPreviewTB.BackColor = dlg.Color;
+      ((IDataRow)LineSelectCB.SelectedValue).Color = dlg.Color;
+    }
+
+    private IList<int> GetThicknesses() {
+      return new List<int>(new[] {1, 2, 3, 4, 5, 6, 7, 8});
+    }
+
+    private IList<DrawingStyle> GetStyles() {
+      return new List<DrawingStyle>(new[] {DrawingStyle.Solid, DrawingStyle.Dashed});
+    }
+
+    private void btnChangeLegendFont_Click(object sender, EventArgs e) {
+      fdFont.Font = viewSettings.LegendFont;
+      fdFont.Color = viewSettings.LegendColor;
+
+      DialogResult dr = fdFont.ShowDialog();
+
+      if (dr == DialogResult.OK) {
+        viewSettings.LegendFont = fdFont.Font;
+        viewSettings.LegendColor = fdFont.Color;
+
+        viewSettings.UpdateView();
+      }
+    }
+
+    private void btnChangeTitleFont_Click(object sender, EventArgs e) {
+      fdFont.Font = viewSettings.TitleFont;
+      fdFont.Color = viewSettings.TitleColor;
+
+      DialogResult dr = fdFont.ShowDialog();
+
+      if (dr == DialogResult.OK) {
+        viewSettings.TitleFont = fdFont.Font;
+        viewSettings.TitleColor = fdFont.Color;
+
+        viewSettings.UpdateView();
+      }
+    }
+
+    private void btnChangeXAxisFont_Click(object sender, EventArgs e) {
+      fdFont.Font = viewSettings.XAxisFont;
+      fdFont.Color = viewSettings.XAxisColor;
+
+      DialogResult dr = fdFont.ShowDialog();
+
+      if (dr == DialogResult.OK) {
+        viewSettings.XAxisFont = fdFont.Font;
+        viewSettings.XAxisColor = fdFont.Color;
+
+        viewSettings.UpdateView();
+      }
+    }
+
+    private void Options_Load(object sender, EventArgs e) {
+      InitTabPageLines();
+      InitTabPageYAxes();
+    }
+
+    private void InitTabPageLines() {
+      if (model.Rows.Count != 0) {
+        int index = 0;
+        oldLineParams = new LineParams[model.Rows.Count];
+        foreach (var row in model.Rows) {
+          oldLineParams[index++] = new LineParams(row);
+        }
+        LineThicknessCB.DataSource = GetThicknesses();
+        LinestyleCB.DataSource = GetStyles();
+        LinestyleCB.SelectedItem = model.Rows[0].Style;
+        LineThicknessCB.SelectedItem = model.Rows[0].Thickness;
+        MarkercheckBox.Checked = model.Rows[0].ShowMarkers;
+
+        LineSelectCB.DataSource = model.Rows;
+        LineSelectCB.DisplayMember = "Label";
+
+
+        LineSelectCB.SelectedIndex = 0;
+        LineSelectCB_SelectedIndexChanged(this, null);
+      }
+    }
+
+    private void InitTabPageYAxes() {
+      ShowYAxisBoxes = new Dictionary<CheckBox, bool>();
+      yAxisClipChangeableBoxes = new Dictionary<CheckBox, bool>();
+
+      for (int i = 0; i < model.YAxes.Count; i++) {
+        YAxisDescriptor yAxisDescriptor = model.YAxes[i];
+
+        CheckBox cbxShowYAxis = new CheckBox();
+        cbxShowYAxis.Text = yAxisDescriptor.Label;
+        cbxShowYAxis.Checked = yAxisDescriptor.ShowYAxis;
+        ShowYAxisBoxes[cbxShowYAxis] = yAxisDescriptor.ShowYAxis;
+        cbxShowYAxis.CheckedChanged += delegate { yAxisDescriptor.ShowYAxis = cbxShowYAxis.Checked; };
+
+        flpShowYAxis.Controls.Add(cbxShowYAxis);
+
+        CheckBox cbxClipChangeable = new CheckBox();
+        cbxClipChangeable.Text = yAxisDescriptor.Label;
+        cbxClipChangeable.Checked = yAxisDescriptor.ClipChangeable;
+        yAxisClipChangeableBoxes[cbxClipChangeable] = yAxisDescriptor.ClipChangeable;
+        cbxClipChangeable.CheckedChanged += delegate { yAxisDescriptor.ClipChangeable = cbxClipChangeable.Checked; };
+
+        flpYAxisClipChangeable.Controls.Add(cbxClipChangeable);
+      }
+    }
+
+    private void LineSelectCB_SelectedIndexChanged(object sender, EventArgs e) {
+      if (LineSelectCB.SelectedValue != null) {
+        /*  int index =
+            LineThicknessCB.FindStringExact(((IDataRow)LineSelectCB.SelectedValue).Thickness.ToString());
+          LineThicknessCB.SelectedIndex = index;
+          index = LinestyleCB.FindStringExact(((IDataRow)LineSelectCB.SelectedValue).Style.ToString());
+          LinestyleCB.SelectedIndex = index;  */
+        LineThicknessCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Thickness;
+        LinestyleCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Style;
+        ColorPreviewTB.BackColor = ((IDataRow)LineSelectCB.SelectedValue).Color;
+        MarkercheckBox.Checked = ((IDataRow)LineSelectCB.SelectedValue).ShowMarkers;
+      }
+    }
+
+    private void cbLegendPosition_SelectedIndexChanged(object sender, EventArgs e) {
+      viewSettings.LegendPosition = (LegendPosition)cbLegendPosition.SelectedItem;
+      viewSettings.UpdateView();
+    }
+
+    private void LinestyleCB_SelectedIndexChanged(object sender, EventArgs e) {
+      if (LineSelectCB.SelectedValue != null) {
+        ((IDataRow)LineSelectCB.SelectedValue).Style = (DrawingStyle)LinestyleCB.SelectedItem;
+      }
+    }
+
+    private void LineThicknessCB_SelectedIndexChanged(object sender, EventArgs e) {
+      if (LineSelectCB.SelectedValue != null) {
+        ((IDataRow)LineSelectCB.SelectedValue).Thickness = (int)LineThicknessCB.SelectedItem;
+      }
+    }
+
+    private void MarkercheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (LineSelectCB.SelectedValue != null) {
+        ((IDataRow)LineSelectCB.SelectedValue).ShowMarkers = MarkercheckBox.Checked;
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.resx
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.resx	(revision 1586)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.resx	(revision 1586)
@@ -0,0 +1,123 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="fdFont.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
+</root>
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs	(revision 1585)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs	(revision 1586)
@@ -24,47 +24,16 @@
     /// </summary>
     private void InitializeComponent() {
+      HeuristicLab.Visualization.ChartDataRowsModel chartDataRowsModel1 = new HeuristicLab.Visualization.ChartDataRowsModel();
+      HeuristicLab.Visualization.Options.ViewSettings viewSettings1 = new HeuristicLab.Visualization.Options.ViewSettings();
+      HeuristicLab.Visualization.LabelProvider.ContinuousLabelProvider continuousLabelProvider1 = new HeuristicLab.Visualization.LabelProvider.ContinuousLabelProvider();
       this.OptionsDialogCancelButton = new System.Windows.Forms.Button();
       this.OptionsDialogOkButton = new System.Windows.Forms.Button();
       this.fdFont = new System.Windows.Forms.FontDialog();
-      this.tpTitle = new System.Windows.Forms.TabPage();
-      this.btnChangeTitleFont = new System.Windows.Forms.Button();
-      this.tabPage2 = new System.Windows.Forms.TabPage();
-      this.btnChangeLegendFont = new System.Windows.Forms.Button();
-      this.legendposition = new System.Windows.Forms.Label();
-      this.cbLegendPosition = new System.Windows.Forms.ComboBox();
-      this.tabPage1 = new System.Windows.Forms.TabPage();
-      this.OptionsDialogSelectColorBt = new System.Windows.Forms.Button();
-      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
-      this.label2 = new System.Windows.Forms.Label();
-      this.LinestyleCB = new System.Windows.Forms.ComboBox();
-      this.label1 = new System.Windows.Forms.Label();
-      this.LineSelectCB = new System.Windows.Forms.ComboBox();
-      this.groupBox1 = new System.Windows.Forms.GroupBox();
-      this.label4 = new System.Windows.Forms.Label();
-      this.LineThicknessCB = new System.Windows.Forms.ComboBox();
-      this.label3 = new System.Windows.Forms.Label();
-      this.Optionstabs = new System.Windows.Forms.TabControl();
-      this.tpXAxis = new System.Windows.Forms.TabPage();
-      this.btnChangeXAxisFont = new System.Windows.Forms.Button();
-      this.tpYAxes = new System.Windows.Forms.TabPage();
-      this.gbxYAxisClipChangeable = new System.Windows.Forms.GroupBox();
-      this.flpYAxisClipChangeable = new System.Windows.Forms.FlowLayoutPanel();
-      this.gbxShowYAxis = new System.Windows.Forms.GroupBox();
-      this.flpShowYAxis = new System.Windows.Forms.FlowLayoutPanel();
-      this.MarkercheckBox = new System.Windows.Forms.CheckBox();
-      this.tpTitle.SuspendLayout();
-      this.tabPage2.SuspendLayout();
-      this.tabPage1.SuspendLayout();
-      this.groupBox1.SuspendLayout();
-      this.Optionstabs.SuspendLayout();
-      this.tpXAxis.SuspendLayout();
-      this.tpYAxes.SuspendLayout();
-      this.gbxYAxisClipChangeable.SuspendLayout();
-      this.gbxShowYAxis.SuspendLayout();
+      this.options = new HeuristicLab.Visualization.Options.Options();
       this.SuspendLayout();
       // 
       // OptionsDialogCancelButton
       // 
-      this.OptionsDialogCancelButton.Location = new System.Drawing.Point(213, 232);
+      this.OptionsDialogCancelButton.Location = new System.Drawing.Point(225, 241);
       this.OptionsDialogCancelButton.Name = "OptionsDialogCancelButton";
       this.OptionsDialogCancelButton.Size = new System.Drawing.Size(75, 23);
@@ -76,5 +45,5 @@
       // OptionsDialogOkButton
       // 
-      this.OptionsDialogOkButton.Location = new System.Drawing.Point(132, 232);
+      this.OptionsDialogOkButton.Location = new System.Drawing.Point(132, 241);
       this.OptionsDialogOkButton.Name = "OptionsDialogOkButton";
       this.OptionsDialogOkButton.Size = new System.Drawing.Size(75, 23);
@@ -88,277 +57,23 @@
       this.fdFont.ShowColor = true;
       // 
-      // tpTitle
+      // options
       // 
-      this.tpTitle.Controls.Add(this.btnChangeTitleFont);
-      this.tpTitle.Location = new System.Drawing.Point(4, 22);
-      this.tpTitle.Name = "tpTitle";
-      this.tpTitle.Size = new System.Drawing.Size(284, 199);
-      this.tpTitle.TabIndex = 2;
-      this.tpTitle.Text = "Title";
-      this.tpTitle.UseVisualStyleBackColor = true;
-      // 
-      // btnChangeTitleFont
-      // 
-      this.btnChangeTitleFont.Location = new System.Drawing.Point(3, 3);
-      this.btnChangeTitleFont.Name = "btnChangeTitleFont";
-      this.btnChangeTitleFont.Size = new System.Drawing.Size(94, 23);
-      this.btnChangeTitleFont.TabIndex = 1;
-      this.btnChangeTitleFont.Text = "Change Font";
-      this.btnChangeTitleFont.UseVisualStyleBackColor = true;
-      this.btnChangeTitleFont.Click += new System.EventHandler(this.btnChangeTitleFont_Click);
-      // 
-      // tabPage2
-      // 
-      this.tabPage2.Controls.Add(this.btnChangeLegendFont);
-      this.tabPage2.Controls.Add(this.legendposition);
-      this.tabPage2.Controls.Add(this.cbLegendPosition);
-      this.tabPage2.Location = new System.Drawing.Point(4, 22);
-      this.tabPage2.Name = "tabPage2";
-      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
-      this.tabPage2.Size = new System.Drawing.Size(284, 199);
-      this.tabPage2.TabIndex = 1;
-      this.tabPage2.Text = "Legend";
-      this.tabPage2.UseVisualStyleBackColor = true;
-      // 
-      // btnChangeLegendFont
-      // 
-      this.btnChangeLegendFont.Location = new System.Drawing.Point(3, 6);
-      this.btnChangeLegendFont.Name = "btnChangeLegendFont";
-      this.btnChangeLegendFont.Size = new System.Drawing.Size(94, 23);
-      this.btnChangeLegendFont.TabIndex = 2;
-      this.btnChangeLegendFont.Text = "Change Font";
-      this.btnChangeLegendFont.UseVisualStyleBackColor = true;
-      this.btnChangeLegendFont.Click += new System.EventHandler(this.btnChangeLegendFont_Click);
-      // 
-      // legendposition
-      // 
-      this.legendposition.AutoSize = true;
-      this.legendposition.Location = new System.Drawing.Point(8, 38);
-      this.legendposition.Name = "legendposition";
-      this.legendposition.Size = new System.Drawing.Size(82, 13);
-      this.legendposition.TabIndex = 1;
-      this.legendposition.Text = "Legendposition:";
-      // 
-      // cbLegendPosition
-      // 
-      this.cbLegendPosition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.cbLegendPosition.FormattingEnabled = true;
-      this.cbLegendPosition.Location = new System.Drawing.Point(96, 35);
-      this.cbLegendPosition.Name = "cbLegendPosition";
-      this.cbLegendPosition.Size = new System.Drawing.Size(121, 21);
-      this.cbLegendPosition.TabIndex = 0;
-      this.cbLegendPosition.SelectedIndexChanged += new System.EventHandler(this.cbLegendPosition_SelectedIndexChanged);
-      // 
-      // tabPage1
-      // 
-      this.tabPage1.Controls.Add(this.OptionsDialogSelectColorBt);
-      this.tabPage1.Controls.Add(this.ColorPreviewTB);
-      this.tabPage1.Controls.Add(this.label2);
-      this.tabPage1.Controls.Add(this.LinestyleCB);
-      this.tabPage1.Controls.Add(this.label1);
-      this.tabPage1.Controls.Add(this.LineSelectCB);
-      this.tabPage1.Controls.Add(this.groupBox1);
-      this.tabPage1.Location = new System.Drawing.Point(4, 22);
-      this.tabPage1.Name = "tabPage1";
-      this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
-      this.tabPage1.Size = new System.Drawing.Size(284, 199);
-      this.tabPage1.TabIndex = 0;
-      this.tabPage1.Text = "Linestyle";
-      this.tabPage1.UseVisualStyleBackColor = true;
-      // 
-      // OptionsDialogSelectColorBt
-      // 
-      this.OptionsDialogSelectColorBt.Location = new System.Drawing.Point(217, 126);
-      this.OptionsDialogSelectColorBt.Name = "OptionsDialogSelectColorBt";
-      this.OptionsDialogSelectColorBt.Size = new System.Drawing.Size(50, 23);
-      this.OptionsDialogSelectColorBt.TabIndex = 7;
-      this.OptionsDialogSelectColorBt.Text = "Select";
-      this.OptionsDialogSelectColorBt.UseVisualStyleBackColor = true;
-      this.OptionsDialogSelectColorBt.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
-      // 
-      // ColorPreviewTB
-      // 
-      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
-      this.ColorPreviewTB.Name = "ColorPreviewTB";
-      this.ColorPreviewTB.ReadOnly = true;
-      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
-      this.ColorPreviewTB.TabIndex = 6;
-      // 
-      // label2
-      // 
-      this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(36, 80);
-      this.label2.Name = "label2";
-      this.label2.Size = new System.Drawing.Size(30, 13);
-      this.label2.TabIndex = 3;
-      this.label2.Text = "Style";
-      // 
-      // LinestyleCB
-      // 
-      this.LinestyleCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LinestyleCB.FormattingEnabled = true;
-      this.LinestyleCB.Location = new System.Drawing.Point(146, 73);
-      this.LinestyleCB.Name = "LinestyleCB";
-      this.LinestyleCB.Size = new System.Drawing.Size(121, 21);
-      this.LinestyleCB.TabIndex = 2;
-      this.LinestyleCB.SelectedIndexChanged += new System.EventHandler(this.LinestyleCB_SelectedIndexChanged);
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(7, 37);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(72, 13);
-      this.label1.TabIndex = 1;
-      this.label1.Text = "Selected Line";
-      // 
-      // LineSelectCB
-      // 
-      this.LineSelectCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LineSelectCB.FormattingEnabled = true;
-      this.LineSelectCB.Location = new System.Drawing.Point(146, 30);
-      this.LineSelectCB.Name = "LineSelectCB";
-      this.LineSelectCB.Size = new System.Drawing.Size(121, 21);
-      this.LineSelectCB.TabIndex = 0;
-      this.LineSelectCB.SelectedIndexChanged += new System.EventHandler(this.LineSelectCB_SelectedIndexChanged);
-      // 
-      // groupBox1
-      // 
-      this.groupBox1.Controls.Add(this.MarkercheckBox);
-      this.groupBox1.Controls.Add(this.label4);
-      this.groupBox1.Controls.Add(this.LineThicknessCB);
-      this.groupBox1.Controls.Add(this.label3);
-      this.groupBox1.Location = new System.Drawing.Point(4, 54);
-      this.groupBox1.Name = "groupBox1";
-      this.groupBox1.Size = new System.Drawing.Size(274, 129);
-      this.groupBox1.TabIndex = 9;
-      this.groupBox1.TabStop = false;
-      this.groupBox1.Text = "Details";
-      // 
-      // label4
-      // 
-      this.label4.AutoSize = true;
-      this.label4.Location = new System.Drawing.Point(33, 77);
-      this.label4.Name = "label4";
-      this.label4.Size = new System.Drawing.Size(31, 13);
-      this.label4.TabIndex = 8;
-      this.label4.Text = "Color";
-      // 
-      // LineThicknessCB
-      // 
-      this.LineThicknessCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LineThicknessCB.FormattingEnabled = true;
-      this.LineThicknessCB.Location = new System.Drawing.Point(142, 46);
-      this.LineThicknessCB.Name = "LineThicknessCB";
-      this.LineThicknessCB.Size = new System.Drawing.Size(121, 21);
-      this.LineThicknessCB.TabIndex = 4;
-      this.LineThicknessCB.SelectedIndexChanged += new System.EventHandler(this.LineThicknessCB_SelectedIndexChanged);
-      // 
-      // label3
-      // 
-      this.label3.AutoSize = true;
-      this.label3.Location = new System.Drawing.Point(32, 52);
-      this.label3.Name = "label3";
-      this.label3.Size = new System.Drawing.Size(56, 13);
-      this.label3.TabIndex = 5;
-      this.label3.Text = "Thickness";
-      // 
-      // Optionstabs
-      // 
-      this.Optionstabs.Controls.Add(this.tabPage1);
-      this.Optionstabs.Controls.Add(this.tabPage2);
-      this.Optionstabs.Controls.Add(this.tpTitle);
-      this.Optionstabs.Controls.Add(this.tpXAxis);
-      this.Optionstabs.Controls.Add(this.tpYAxes);
-      this.Optionstabs.Location = new System.Drawing.Point(0, 1);
-      this.Optionstabs.Name = "Optionstabs";
-      this.Optionstabs.SelectedIndex = 0;
-      this.Optionstabs.Size = new System.Drawing.Size(292, 225);
-      this.Optionstabs.TabIndex = 0;
-      // 
-      // tpXAxis
-      // 
-      this.tpXAxis.Controls.Add(this.btnChangeXAxisFont);
-      this.tpXAxis.Location = new System.Drawing.Point(4, 22);
-      this.tpXAxis.Name = "tpXAxis";
-      this.tpXAxis.Size = new System.Drawing.Size(284, 199);
-      this.tpXAxis.TabIndex = 3;
-      this.tpXAxis.Text = "X-Axis";
-      this.tpXAxis.UseVisualStyleBackColor = true;
-      // 
-      // btnChangeXAxisFont
-      // 
-      this.btnChangeXAxisFont.Location = new System.Drawing.Point(3, 3);
-      this.btnChangeXAxisFont.Name = "btnChangeXAxisFont";
-      this.btnChangeXAxisFont.Size = new System.Drawing.Size(94, 23);
-      this.btnChangeXAxisFont.TabIndex = 2;
-      this.btnChangeXAxisFont.Text = "Change Font";
-      this.btnChangeXAxisFont.UseVisualStyleBackColor = true;
-      this.btnChangeXAxisFont.Click += new System.EventHandler(this.btnChangeXAxisFont_Click);
-      // 
-      // tpYAxes
-      // 
-      this.tpYAxes.Controls.Add(this.gbxYAxisClipChangeable);
-      this.tpYAxes.Controls.Add(this.gbxShowYAxis);
-      this.tpYAxes.Location = new System.Drawing.Point(4, 22);
-      this.tpYAxes.Name = "tpYAxes";
-      this.tpYAxes.Padding = new System.Windows.Forms.Padding(3);
-      this.tpYAxes.Size = new System.Drawing.Size(284, 199);
-      this.tpYAxes.TabIndex = 4;
-      this.tpYAxes.Text = "Y-Axes";
-      this.tpYAxes.UseVisualStyleBackColor = true;
-      // 
-      // gbxYAxisClipChangeable
-      // 
-      this.gbxYAxisClipChangeable.AutoSize = true;
-      this.gbxYAxisClipChangeable.Controls.Add(this.flpYAxisClipChangeable);
-      this.gbxYAxisClipChangeable.Location = new System.Drawing.Point(0, 82);
-      this.gbxYAxisClipChangeable.Name = "gbxYAxisClipChangeable";
-      this.gbxYAxisClipChangeable.Size = new System.Drawing.Size(281, 76);
-      this.gbxYAxisClipChangeable.TabIndex = 1;
-      this.gbxYAxisClipChangeable.TabStop = false;
-      this.gbxYAxisClipChangeable.Text = "Y-Axis-Clip changeable";
-      // 
-      // flpYAxisClipChangeable
-      // 
-      this.flpYAxisClipChangeable.AutoSize = true;
-      this.flpYAxisClipChangeable.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.flpYAxisClipChangeable.FlowDirection = System.Windows.Forms.FlowDirection.TopDown;
-      this.flpYAxisClipChangeable.Location = new System.Drawing.Point(3, 16);
-      this.flpYAxisClipChangeable.Name = "flpYAxisClipChangeable";
-      this.flpYAxisClipChangeable.Size = new System.Drawing.Size(275, 57);
-      this.flpYAxisClipChangeable.TabIndex = 0;
-      // 
-      // gbxShowYAxis
-      // 
-      this.gbxShowYAxis.AutoSize = true;
-      this.gbxShowYAxis.Controls.Add(this.flpShowYAxis);
-      this.gbxShowYAxis.Location = new System.Drawing.Point(0, 0);
-      this.gbxShowYAxis.Name = "gbxShowYAxis";
-      this.gbxShowYAxis.Size = new System.Drawing.Size(281, 76);
-      this.gbxShowYAxis.TabIndex = 0;
-      this.gbxShowYAxis.TabStop = false;
-      this.gbxShowYAxis.Text = "Show Y-Axis";
-      // 
-      // flpShowYAxis
-      // 
-      this.flpShowYAxis.AutoSize = true;
-      this.flpShowYAxis.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.flpShowYAxis.FlowDirection = System.Windows.Forms.FlowDirection.TopDown;
-      this.flpShowYAxis.Location = new System.Drawing.Point(3, 16);
-      this.flpShowYAxis.Name = "flpShowYAxis";
-      this.flpShowYAxis.Size = new System.Drawing.Size(275, 57);
-      this.flpShowYAxis.TabIndex = 0;
-      // 
-      // MarkercheckBox
-      // 
-      this.MarkercheckBox.AutoSize = true;
-      this.MarkercheckBox.Location = new System.Drawing.Point(142, 106);
-      this.MarkercheckBox.Name = "MarkercheckBox";
-      this.MarkercheckBox.Size = new System.Drawing.Size(59, 17);
-      this.MarkercheckBox.TabIndex = 9;
-      this.MarkercheckBox.Text = "Marker";
-      this.MarkercheckBox.UseVisualStyleBackColor = true;
-      this.MarkercheckBox.CheckedChanged += new System.EventHandler(this.MarkercheckBox_CheckedChanged);
+      this.options.Location = new System.Drawing.Point(2, 3);
+      chartDataRowsModel1.ShowXAxisLabel = true;
+      chartDataRowsModel1.Title = "Title";
+      viewSettings1.LegendColor = System.Drawing.Color.Blue;
+      viewSettings1.LegendFont = new System.Drawing.Font("Arial", 8F);
+      viewSettings1.LegendPosition = HeuristicLab.Visualization.Legend.LegendPosition.Bottom;
+      viewSettings1.TitleColor = System.Drawing.Color.Blue;
+      viewSettings1.TitleFont = new System.Drawing.Font("Arial", 8F);
+      viewSettings1.XAxisColor = System.Drawing.Color.Blue;
+      viewSettings1.XAxisFont = new System.Drawing.Font("Arial", 8F);
+      chartDataRowsModel1.ViewSettings = viewSettings1;
+      chartDataRowsModel1.XAxisLabel = "";
+      chartDataRowsModel1.XAxisLabelProvider = continuousLabelProvider1;
+      this.options.Model = chartDataRowsModel1;
+      this.options.Name = "options";
+      this.options.Size = new System.Drawing.Size(298, 232);
+      this.options.TabIndex = 3;
       // 
       // OptionsDialog
@@ -366,28 +81,12 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(292, 266);
+      this.ClientSize = new System.Drawing.Size(302, 270);
+      this.Controls.Add(this.options);
       this.Controls.Add(this.OptionsDialogOkButton);
       this.Controls.Add(this.OptionsDialogCancelButton);
-      this.Controls.Add(this.Optionstabs);
       this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
       this.MaximizeBox = false;
       this.Name = "OptionsDialog";
       this.Text = "OptionsDialog";
-      this.Load += new System.EventHandler(this.OptionsDialog_Load);
-      this.tpTitle.ResumeLayout(false);
-      this.tabPage2.ResumeLayout(false);
-      this.tabPage2.PerformLayout();
-      this.tabPage1.ResumeLayout(false);
-      this.tabPage1.PerformLayout();
-      this.groupBox1.ResumeLayout(false);
-      this.groupBox1.PerformLayout();
-      this.Optionstabs.ResumeLayout(false);
-      this.tpXAxis.ResumeLayout(false);
-      this.tpYAxes.ResumeLayout(false);
-      this.tpYAxes.PerformLayout();
-      this.gbxYAxisClipChangeable.ResumeLayout(false);
-      this.gbxYAxisClipChangeable.PerformLayout();
-      this.gbxShowYAxis.ResumeLayout(false);
-      this.gbxShowYAxis.PerformLayout();
       this.ResumeLayout(false);
 
@@ -399,30 +98,5 @@
     private System.Windows.Forms.Button OptionsDialogOkButton;
     private System.Windows.Forms.FontDialog fdFont;
-    private System.Windows.Forms.TabPage tpTitle;
-    private System.Windows.Forms.Button btnChangeTitleFont;
-    private System.Windows.Forms.TabPage tabPage2;
-    private System.Windows.Forms.TabPage tabPage1;
-    private System.Windows.Forms.Button OptionsDialogSelectColorBt;
-    private System.Windows.Forms.TextBox ColorPreviewTB;
-    private System.Windows.Forms.Label label2;
-    private System.Windows.Forms.ComboBox LinestyleCB;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.ComboBox LineSelectCB;
-    private System.Windows.Forms.GroupBox groupBox1;
-    private System.Windows.Forms.Label label4;
-    private System.Windows.Forms.ComboBox cbLegendPosition;
-    private System.Windows.Forms.Label legendposition;
-    private System.Windows.Forms.ComboBox LineThicknessCB;
-    private System.Windows.Forms.Label label3;
-    private System.Windows.Forms.TabControl Optionstabs;
-    private System.Windows.Forms.Button btnChangeLegendFont;
-    private System.Windows.Forms.TabPage tpXAxis;
-    private System.Windows.Forms.Button btnChangeXAxisFont;
-    private System.Windows.Forms.TabPage tpYAxes;
-    private System.Windows.Forms.GroupBox gbxShowYAxis;
-    private System.Windows.Forms.GroupBox gbxYAxisClipChangeable;
-    private System.Windows.Forms.FlowLayoutPanel flpYAxisClipChangeable;
-    private System.Windows.Forms.FlowLayoutPanel flpShowYAxis;
-    private System.Windows.Forms.CheckBox MarkercheckBox;
+    private Options options;
   }
 }
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.cs	(revision 1585)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.cs	(revision 1586)
@@ -1,233 +1,20 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Drawing;
 using System.Windows.Forms;
-using HeuristicLab.Visualization.Legend;
 
 namespace HeuristicLab.Visualization.Options {
   public partial class OptionsDialog : Form {
-    private readonly IChartDataRowsModel model;
-    private readonly ViewSettings viewSettings;
-    private readonly ViewSettings oldViewSettings;
-    private LineParams[] oldLineParams;
-    private Dictionary<CheckBox,bool> ShowYAxisBoxes;
-    private Dictionary<CheckBox,bool> yAxisClipChangeableBoxes;
-
-    internal class LineParams {
-      string Label { get; set; }
-      Color Color { get; set; }
-      bool ShowMarkers { get; set; }
-      int Thickness { get; set; }
-      DrawingStyle Style { get; set; }
-      private readonly IDataRow row;
-
-      public LineParams(IDataRow row) {
-        Label = row.Label;
-        Color = row.Color;
-        Thickness = row.Thickness;
-        Style = row.Style;
-        this.row = row;
-        this.ShowMarkers = row.ShowMarkers; 
-      }
-
-      public void applySettings() {
-        row.Label = Label;
-        row.Color = Color;
-        row.Thickness = Thickness;
-        row.Style = Style;
-        row.ShowMarkers = this.ShowMarkers;
-      }
-    }
-
     public OptionsDialog(IChartDataRowsModel model) {
       InitializeComponent();
 
-      this.model = model;
-      viewSettings = model.ViewSettings;
-      oldViewSettings = new ViewSettings(model.ViewSettings);
-
-      cbLegendPosition.Items.Add(LegendPosition.Top);
-      cbLegendPosition.Items.Add(LegendPosition.Bottom);
-      cbLegendPosition.Items.Add(LegendPosition.Left);
-      cbLegendPosition.Items.Add(LegendPosition.Right);
-
-      cbLegendPosition.SelectedItem = viewSettings.LegendPosition;
+      options.Model = model;
     }
 
-    private void OptionsDialogSelectColorBtn_Click(object sender, EventArgs e) {
-      ColorDialog dlg = new ColorDialog();
-      dlg.ShowDialog();
-      ColorPreviewTB.BackColor = dlg.Color;
-      ((IDataRow)LineSelectCB.SelectedValue).Color = dlg.Color;
-    }
-
-    public IList<int> GetThicknesses() {
-      return new List<int>(new int[] {1, 2, 3, 4, 5, 6, 7, 8});
-    }
-
-    public IList<DrawingStyle> GetStyles() {
-      return new List<DrawingStyle>(new DrawingStyle[] {DrawingStyle.Solid, DrawingStyle.Dashed});
-    }
-
-    private void OptionsDialog_Load(object sender, EventArgs e) {
-      InitTabPageLines();
-      InitTabPageYAxes();
-    }
-
-    private void InitTabPageLines() {
-      if (model.Rows.Count != 0) {
-        int index = 0;
-        oldLineParams = new LineParams[model.Rows.Count];
-        foreach (var row in model.Rows) {
-          oldLineParams[index++]= new LineParams(row);
-        }
-        LineThicknessCB.DataSource = GetThicknesses();
-        LinestyleCB.DataSource = GetStyles();
-        LinestyleCB.SelectedItem = model.Rows[0].Style;
-        LineThicknessCB.SelectedItem = model.Rows[0].Thickness;
-        MarkercheckBox.Checked = model.Rows[0].ShowMarkers;
-
-        LineSelectCB.DataSource = model.Rows;
-        LineSelectCB.DisplayMember = "Label";
-
-        
-        LineSelectCB.SelectedIndex = 0;
-        LineSelectCB_SelectedIndexChanged(this, null);
-        
-      }
-    }
-
-    private void InitTabPageYAxes() {
-      ShowYAxisBoxes = new Dictionary<CheckBox, bool>();
-      yAxisClipChangeableBoxes = new Dictionary<CheckBox, bool>();
-
-      for (int i = 0; i < model.YAxes.Count; i++) {
-        YAxisDescriptor yAxisDescriptor = model.YAxes[i];
-
-        CheckBox cbxShowYAxis = new CheckBox();
-        cbxShowYAxis.Text = yAxisDescriptor.Label;
-        cbxShowYAxis.Checked = yAxisDescriptor.ShowYAxis;
-        ShowYAxisBoxes[cbxShowYAxis] = yAxisDescriptor.ShowYAxis;
-        cbxShowYAxis.CheckedChanged += delegate { yAxisDescriptor.ShowYAxis = cbxShowYAxis.Checked; };
-        
-        flpShowYAxis.Controls.Add(cbxShowYAxis);
-
-        CheckBox cbxClipChangeable = new CheckBox();
-        cbxClipChangeable.Text = yAxisDescriptor.Label;
-        cbxClipChangeable.Checked = yAxisDescriptor.ClipChangeable;
-        yAxisClipChangeableBoxes[cbxClipChangeable] = yAxisDescriptor.ClipChangeable; 
-        cbxClipChangeable.CheckedChanged += delegate { yAxisDescriptor.ClipChangeable = cbxClipChangeable.Checked; };
-
-        flpYAxisClipChangeable.Controls.Add(cbxClipChangeable);
-      }
-    }
-
-    private void LineSelectCB_SelectedIndexChanged(object sender, EventArgs e) {
-      if (LineSelectCB.SelectedValue != null) {
-      /*  int index =
-          LineThicknessCB.FindStringExact(((IDataRow)LineSelectCB.SelectedValue).Thickness.ToString());
-        LineThicknessCB.SelectedIndex = index;
-        index = LinestyleCB.FindStringExact(((IDataRow)LineSelectCB.SelectedValue).Style.ToString());
-        LinestyleCB.SelectedIndex = index;  */
-        LineThicknessCB.SelectedItem = ((IDataRow) LineSelectCB.SelectedValue).Thickness;
-        LinestyleCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Style;
-        ColorPreviewTB.BackColor = ((IDataRow)LineSelectCB.SelectedValue).Color;
-        MarkercheckBox.Checked = ((IDataRow) LineSelectCB.SelectedValue).ShowMarkers;
-      }
-    }
-
-    
     private void OptionsDialogOkButton_Click(object sender, EventArgs e) {
       Close();
     }
-    
-    private void cbLegendPosition_SelectedIndexChanged(object sender, EventArgs e) {
-      viewSettings.LegendPosition = (LegendPosition)cbLegendPosition.SelectedItem;
-      viewSettings.UpdateView();
-    }
-
-    private void btnChangeTitleFont_Click(object sender, EventArgs e) {
-      fdFont.Font = viewSettings.TitleFont;
-      fdFont.Color = viewSettings.TitleColor;
-
-      DialogResult dr = fdFont.ShowDialog();
-
-      if(dr == DialogResult.OK) {
-        viewSettings.TitleFont = fdFont.Font;
-        viewSettings.TitleColor = fdFont.Color;
-
-        viewSettings.UpdateView();
-      }
-    }
-
-    private void btnChangeLegendFont_Click(object sender, EventArgs e) {
-      fdFont.Font = viewSettings.LegendFont;
-      fdFont.Color = viewSettings.LegendColor;
-
-      DialogResult dr = fdFont.ShowDialog();
-
-      if (dr == DialogResult.OK) {
-        viewSettings.LegendFont = fdFont.Font;
-        viewSettings.LegendColor = fdFont.Color;
-
-        viewSettings.UpdateView();
-      }
-    }
-
-    private void btnChangeXAxisFont_Click(object sender, EventArgs e) {
-      fdFont.Font = viewSettings.XAxisFont;
-      fdFont.Color = viewSettings.XAxisColor;
-
-      DialogResult dr = fdFont.ShowDialog();
-
-      if (dr == DialogResult.OK) {
-        viewSettings.XAxisFont = fdFont.Font;
-        viewSettings.XAxisColor = fdFont.Color;
-
-        viewSettings.UpdateView();
-      }
-    }
 
     private void OptionsDialogResetButton_Click(object sender, EventArgs e) {
-      foreach (var param in oldLineParams) {
-        param.applySettings();
-      }
-
-      foreach (var box in ShowYAxisBoxes) {
-        box.Key.Checked = box.Value;
-      }
-
-      foreach (KeyValuePair<CheckBox, bool> box in yAxisClipChangeableBoxes) {
-        box.Key.Checked = box.Value;
-      }
-
-      viewSettings.LegendColor = oldViewSettings.LegendColor;
-      viewSettings.LegendPosition = oldViewSettings.LegendPosition;
-      viewSettings.LegendFont = oldViewSettings.LegendFont;
-      viewSettings.TitleColor = oldViewSettings.TitleColor;
-      viewSettings.TitleFont = oldViewSettings.TitleFont;
-      viewSettings.XAxisColor = oldViewSettings.LegendColor;
-      viewSettings.XAxisFont = oldViewSettings.XAxisFont;
-      viewSettings.UpdateView();
-      cbLegendPosition.SelectedItem = viewSettings.LegendPosition;
-      this.LineSelectCB_SelectedIndexChanged(this,null);
+      options.ResetSettings();
     }
-
-    private void LinestyleCB_SelectedIndexChanged(object sender, EventArgs e) {
-      if (LineSelectCB.SelectedValue != null)
-        ((IDataRow)LineSelectCB.SelectedValue).Style = (DrawingStyle)LinestyleCB.SelectedItem;
-    }
-
-    private void LineThicknessCB_SelectedIndexChanged(object sender, EventArgs e) {
-      if (LineSelectCB.SelectedValue != null)
-        ((IDataRow)LineSelectCB.SelectedValue).Thickness = (int)LineThicknessCB.SelectedItem;
-    }
-
-    private void MarkercheckBox_CheckedChanged(object sender, EventArgs e) {
-      if (LineSelectCB.SelectedValue != null)
-        ((IDataRow) LineSelectCB.SelectedValue).ShowMarkers = MarkercheckBox.Checked;
-    }
-
-
   }
 }
